#version 400
in vec3 myVertex;
in vec3 myNormal;
in vec2 myTexCoord;
in vec3 myTangents;
in vec3 myBinormals;      
out vec3 vPosition;
out vec3 vNormal;
out vec2 vTescoord;
out vec3 vTangents;
out vec3 vBitangent;  
uniform mat3 osg_NormalMatrix;
uniform mat4 osg_ProjectionMatrix;
uniform mat4 osg_ModelViewMatrix;
void main(){
	vTescoord = myTexCoord;	
	vPosition = myVertex;
	vTangents = myTangents;
	vBitangent = myBinormals;	
	vNormal = myNormal;
}
